.686
.model flat,stdcall
option casemap:none
.xmm

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib


.data
ALIGN 16
   z0  dd  0           ; hold temp debugging values
   z1  dd  0
   z2  dd  0
   z3  dd  0
   z4  dd  0

   NOC    dd 0
   GLEinf dd 0

   szNOCC db "Analyzing wsprintf",0
   szfmtN db "NOC : %lu",13,10
          db "GLE : %lu",0
   szNOCT db "The number of characters written by wsprintf",13,10
   szNOC  db 64 dup (0)

   szC    db "NOT operation",0
   szfmtI db "NOT : %lu",13,10
          db "XOR : %lu",13,10
          db "SUB : %lu",13,10
          db "NEG : %lu",13,10
          db "AND : %lu",13,10  ; should be ,0 instead of ,13,10

   szM    db "The Alternatives",13,10
;   szZ    db 256 dup (0)        ; the original buffer
   szZ    db 2048 dup (0)        ; expanded buffer in response to results/feedback
   szA    db 255,255,255,0

.code
start:
   mov z0, 0
   mov z1, 0
   mov z2, 0
   mov z3, 0
   mov z4, 0

   not z0
   xor z1, -1
   mov eax, -1
   sub eax, z2
   mov z2, eax
   neg z3
   sub z3, 1
   not z4
   and z4, -1

   invoke wsprintf,ADDR szZ,ADDR szfmtI,z0,z1,z2,z3,z4
   mov NOC, eax
   invoke GetLastError
   mov GLEinf, eax
   invoke MessageBox, NULL, addr szM, addr szC, MB_OK

   invoke wsprintf,ADDR szNOC,ADDR szfmtN,NOC,GLEinf
   invoke MessageBox, NULL, addr szNOCT, addr szNOCC, MB_OK

   invoke ExitProcess, 0
end start